#!/usr/bin/python
import random, sys
import math, os, time

def printstr(s,n):
# diese funktion druckt den aktuellen Verkehrszustand aus
# die strasse wird als Rand eines Quadrates ausgegeben, in dem sich die Fahrzeuge
# im Uhrzeigersinn bewegen
# "." bedeutet: kein Auto
# Ziffer bedeutet: Auto, das sich mit der Geschwindigkeitsstufe bewegt, die die Ziffer angibt
# (0,...,5)

# fuer linux- oder unix-systeme bitte den folgenden befehl aktivieren:
# os.system("clear")
   os.system("cls")
   sc=range(4*n+5)
   for i in range(4*n+5):
      if s[i]==-1:
         sc[i]='.'
      else:
         sc[i]=s[i]
   print
   for i in range(n+1):
      print sc[i],
   print 
   for i in range(1,n):
      print sc[4*n-i],(2*n-3)*" ",sc[n+i]
   for i in range(3*n,2*n-1,-1):
      print sc[i],
   print
   
nn=input("Gib die Anzahl der Zellen der Strasse ein (durch 4 teilbare Zahl eingeben, z.B. 160): ")
n=nn/4
m=input("Gib die Anzahl der Autos ein: ")
s=range(4*n+5)   
v=range(4*n+5)
timesteps=input("Wieviele Zeitschritte sollen durchgefuehrt werden: ")
# es wird ein ueberlappungsbereich eingefuehrt, damit infos am anfang und am ende der strasse
# einfach korrekt behandelt werden koennen; dieser bereich hat die laenge 5 
# dies entspricht der maximalen geschwindigkeit der autos)
for i in range(0,4*n+5):
   s[i]=-1
   v[i]=-1
   
if m>(4*n):
   sys.exit("Zu viele Autos: ueberpruefe deine Eingabe und starte das Programm erneut")
if m==(4*n):
   print "Stau; die Strasse ist komplett voll und alle Autos stehen."
   timesteps = 1

# belege die Strasse zufaellig mit m Autos, die zufaellige Startgeschwindigkeiten erhalten
mh = 0
while mh<m:
        # waehle zufaellig position fuer neues auto und akzeptiere sie, wenn an dieser
        # position noch kein auto steht (s[i]=-1); setze dann eine zufaellige
        # anfangsgeschwindigkeit zwischen 1 und 5 auf s[i]
   i=random.randint(0,4*n-1)
   if s[i]==-1:
      mh=mh+1
      s[i]=random.randint(1,5)
# uebernehme fuer den ueberlappungsbereich am ende der rundstrasse die werte am anfang der strasse
for i in range(5):
   s[4*n+i]=s[i]
printstr(s,n)

# iteriere ueber die zeitschritte
for it in range(timesteps):
   # beschleunigen
   for i in range(4*n):
      if s[i]!=-1:
         v[i]=min(s[i]+1,5)
   # bremsen
   for i in range(4*n):
      if s[i]!=-1:
         for j in range(1,v[i]+1):
            if s[i+j]!=-1:
               v[i]=j-1
               break
   for i in range(4*n+5):
      s[i]=-1
   # bewegen
   for i in range(4*n):
      if v[i]!=-1:
         s[(i+v[i])%(4*n)]=v[i]
   for i in range(5):
      s[4*n+i]=s[i]
   for i in range(4*n+5):
      v[i]=-1
   printstr(s,n)
   print
   print "Zeitschritt: ", it+1
   # verzoegere Ausgabe um 1 Sekunde
   time.sleep(1)
raw_input("Zum Beenden bitte Eingabetaste druecken")
